TEMPLATE = app
TARGET = ortk
DEPENDPATH += .
INCLUDEPATH += .
CONFIG += console
CONFIG += qt thread
# Dirs

OBJECTS_DIR = release
DESTDIR = release

# Base files

HEADERS += src/content.h src/popup.h src/defs.h src/match.h src/matrice.h src/erreur.h src/makekeys.h src/io_config.h src/exception.h src/ransac.h
SOURCES += src/content.cpp src/main.cpp src/popup.cpp src/exception.c src/io_config.cpp src/makekeys.cpp src/match.c src/matrice.cpp src/erreur.cpp src/ransac.cpp

# Include networking support
QT += network

win32{
	OPENCVDIR = "C:/Program Files/OpenCV"

	exists($$OPENCVDIR) {
		DEFINES += USEOPENCV
		DEFINES += APP_WIN32
		INCLUDEPATH += $${OPENCVDIR}/cv/include $${OPENCVDIR}/cxcore/include $${OPENCVDIR}/otherlibs/highgui ./src
		LIBS += -L$${OPENCVDIR}/lib -lcv -lhighgui -lcxcore
		message("OpenCV libraries found in $${OPENCVDIR}")
	} else {
		message("OpenCV libraries not found.")
	}
}

unix{
	
	OPENCV_TEST = /usr/local/lib/libcv.la
	OPENCVLIB = /usr/local/lib
	OPENCVINCLUDE = /usr/local/include/opencv
	
	exists( $${OPENCV_TEST} ) {
		DEFINES += USEOPENCV
		DEFINES += APP_UNIX
		INCLUDEPATH += $${OPENCVINCLUDE} $${QTINCLUDE} ./src
		LIBS += -L$${OPENCVLIB} -lcv -lhighgui -lcxcore
		message("OpenCV libraries found in $${OPENCVLIB}")
	} else {
		message("OpenCV libraries not found.")
	}
}

# Icon file
win32:RC_FILE = src/application.rc
