/***************************************************************************
 *   Copyright (C) 2007 by ASL-ETH                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include<io_config.h>
using namespace::std;

bool readINI(string key, float &val, ifstream &pf)
{
	string read_str;
	char buff[256];
	bool flag=false;
	string::size_type pos;

	if(!pf.is_open())
		return false;
	
	while(!flag && !pf.eof())
	{

		pf.getline(buff,255); //reading a line (until 255 chars or '/n')
		if(buff[0]=='#') //avoid comments
			continue;
		read_str=buff;
		pos=read_str.find("=");
		if(read_str.substr(0,pos)==key)
		{
			istringstream tmp(read_str.substr(pos+1,read_str.length()-pos));
			tmp>>val;
			flag=true;
		}
	}
	
	return flag;
	
}

bool readINI(string key, int &val, ifstream &pf)
{
	string read_str;
	char buff[256];
	bool flag=false;
	string::size_type pos;

	if(!pf.is_open())
		return false;
	
	while(!flag && !pf.eof())
	{

		pf.getline(buff,255); //reading a line (until 255 chars or '/n')
		if(buff[0]=='#') //avoid comments
			continue;
		read_str=buff;
		pos=read_str.find("=");
		if(read_str.substr(0,pos)==key)
		{
			istringstream tmp(read_str.substr(pos+1,read_str.length()-pos));
			tmp>>val;
			flag=true;
		}
	}
	
	return flag;
	
}
